#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell-event.h"
#include "rof-event.h"

#include <float.h>
#include <limits.h>

using namespace std;

/*----------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------- n`Ep[^lE̓f[^̎󂯓niEjEoij̐ -----------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------*/


// ܓxEoxEox30b̒EőlEԒlEŏlE[̃Obhǂ߂B
// 30b(1km)f̊iqTCYłBlatitude(ܓx)̃ObhTCY͖111.2kmœłB
// longitude(ox)̃TCY͈ܓxɂĈقȂ̂ŌvZKvB

// vZł͍łk()̍s0sƍlĂB(20120211)

void Cell::setElevation (
	int rowStep, // row counter
	int colStep, // column counter
	int nRow, // number of row for the study area
	int nCol, //number of column for the study area
	float SWlat, // South west corner of latitude
	float SWlon, // South west corner of longitude
	float medElevation, // elevation at grid center
	int TopoScale // ratio of spatial resolution to 3 second (10 means 30 second)
)
{
	topoScale = TopoScale;

	// setting latitude in 'sec' unit
	latitude  = (SWlat*3600) + 3.0*topoScale*(nRow-rowStep-1) + 1.5*topoScale;

	// setting longitude in 'sec' unit
	longitude = (SWlon*3600) + 3.0*topoScale*colStep + 1.5*topoScale;

	// setting length (km) for 1 degree in longitude direction
	longitudinalLength = (float)(92.6886 * topoScale)*(float)cos(latitude/3600.0/180.0*3.14);

	med = medElevation;
	
	if (rowStep==0 || rowStep==nRow-1 || colStep==0 || colStep==nCol-1) {
		isThisGridEnd = true; //Obh̒[ɂ
		gridKind = -1; // edge of study region. Added on May 20, 2013.
	}
	else {
		isThisGridEnd = false;
		gridKind = 1;  // inside of study region. Added on May 20, 2013.
	}
	
	// iqԍLĂ for debug
	row = nRow - rowStep;
	col = colStep + 1;

}

// EאڃObhEObh
void Cell::setNULL()
{
	down=10;

	downStreamGrid=NULL;
	for(int i=0; i<7; i++) upStreamGrid[i]=NULL;
	ROFCell=NULL;
}


// o"downStreamGrid"ɒl
void Cell::setDownStreamGrid(int row, int col, class Cell** cell2)
{
	switch(down){
	case 1:	downStreamGrid = &cell2[row-1][col];
		break;
		
	case 2:	downStreamGrid = &cell2[row-1][col+1];
		break;
		
	case 3:	downStreamGrid = &cell2[row][col+1];
		break;
		
	case 4: downStreamGrid = &cell2[row+1][col+1];
		break;
		
	case 5: downStreamGrid = &cell2[row+1][col];
		break;
		
	case 6: downStreamGrid = &cell2[row+1][col-1];
		break;
		
	case 7: downStreamGrid = &cell2[row][col-1];
		break;
		
	case 8: downStreamGrid = &cell2[row-1][col-1];
		break;
		
	default: break;
	}
}


// o"upStreamGrid"ɒl
void Cell::setUpStreamGrid()
{
	for(int i=0; i<7; i++){
		
		if(downStreamGrid->upStreamGrid[i]==NULL){
			downStreamGrid->upStreamGrid[i]=this;
			break;
		}
		
	}
}

// 㗬Obh̐𐔂
void Cell::countNumberOfUpStreamGrid()
{
	numberOfUpStreamGrid = 0;
	
	for(int i=0; i<7; i++){

		if(upStreamGrid[i]!=NULL){
			numberOfUpStreamGrid++;
		}
		else{
			break;
		}
	}
	
}

//Edited by K. Miyawaki 2015
// ̃ObhbasinID߂
void Cell::setBasinID()
{
	int bID;
	class Cell* object;
	
	object = this;
	while (object->basinID == -1) {
		if(object->downStreamGrid == NULL) {
			break;
		}
		object = object->downStreamGrid;
	}
	bID = object->basinID;

	object = this;
	while (object->basinID == -1) {
		if (object->downStreamGrid == NULL) {
			break;
		}
		object->basinID = bID;
		object = object->downStreamGrid;
	}
}



// ̃Obh܂܂ROFZ߂
void Cell::setROFCell(ROF** fROF, int row_ROF, int col_ROF, int*& rofRC)
{
	double x=(double)latitude/3600.0;
	double y=(double)longitude/3600.0;
	double distance;
	double distance_min;

	distance_min=100000000000000000000000000000.0;

	for(int i=0; i<row_ROF; i++){
		for(int j=0; j<col_ROF; j++){

			distance = sqrt(pow(x-(double)fROF[i][j].latitude, 2)+pow(y-(double)fROF[i][j].longitude, 2));
			
			if(distance < distance_min){
				
				ROFCell=&fROF[i][j];
				distance_min = distance;
				rofRC[0] = i;
				rofRC[1] = j;
			}
		}
	}
}
// return setROFCell
void Cell::PutROFCell(ROF** fROF, int ix, int iy)
{
	ROFCell = &fROF[ix][iy];
}


// p^̐ݒ
void Cell::Set_parameter(double wMan_channel, double wMan_slope, 
double wKa, double wDa, double wDm, double wBeta, double wsL, double wsB, int wthre_basin, 
int x_Div, int t_Div, double theta, int t_step_num, int Ndays)
{

	//n`f[^ Topographic data
	switch(down){
	case 1:	mL = (92.6886 * topoScale);
		break;
		
	case 2:	mL = sqrt(pow((92.6886 * topoScale), 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 3:	mL = longitudinalLength;
		break;
		
	case 4: mL = sqrt(pow((92.6886 * topoScale), 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 5: mL = (92.6886 * topoScale);
		break;
		
	case 6: mL = sqrt(pow((92.6886 * topoScale), 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 7: mL = longitudinalLength;
		break;
		
	case 8: mL = sqrt(pow((92.6886 * topoScale), 2.0) + pow((double)longitudinalLength, 2.0));
		break;

	case 0: mL = sqrt(pow((92.6886 * topoScale), 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	default: break;
	}	

	if(downStreamGrid!=NULL){ 
		
		mG = tan((med - downStreamGrid->med) / mL);

		// ovZ\ɂ邽߁CΖʌz0.00001̍ŏl݂
		//if(mG < 0.001) mG = 0.001;
		if(mG < 0.00001) mG = 0.00001;

	}
	else{
		// ovZ\ɂ邽߁CΖʌz0.00001̍ŏl݂
		//mG = (float)0.001;
		mG = (float)0.00001;
	}
	mG = atan(mG); mG = sin(mG); // sin̒lɕϊ

	mthre_basin = wthre_basin; // EWʐ
	mDiv = x_Div;
	mDx = mL / mDiv;
	mDt = t_Div;
	mTheta = theta; 




	//ʂ̃p[^ Common parameters for channels and slopes
	mMan_slope   =  wMan_slope; // Ζʕ̑exW
	mKa   =  wKa; // Oaw̓W
	//mD   =  wD; // yw
	mDa   =  wDa; // Oaw
	mDm   =  wDm; // sOaw
	mBeta   =  wBeta; // sOax\w
	mAlpha_slope = sqrt(mG) / mMan_slope;
	mZ = 1.0;//ʗϊ֌Ŵ߂̃p[^
	mM = 1.0 + 0.666667 * mZ;//ʗϊ֌Ŵ߂̃p[^

	// Oaw̗
	if(mDa < DBL_MIN){ mVa = 0.0;}
	else{ mVa = mKa * mG;}
	// sOaw̍ő嗬
	double qc;
	if(mDm < DBL_MIN){ mQm = 0.0;}
	else{ mQm = mVa/mBeta*mDm;}

	//̊m Allocation of memories for river discharge
	//I_memory is added for dam control scheme by Miyawaki K. 2015
	mQn_memory = new float**[Ndays];
	I_memory = new float**[Ndays];
	
	for(int i=0; i < Ndays; i++){
		mQn_memory[i] = new float*[24];
		I_memory[i] = new float*[24];
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			mQn_memory[i][j] = new float[t_step_num];
			I_memory[i][j] = new float[t_step_num];
		}
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			for (int k=0; k<t_step_num; k++) {
				mQn_memory[i][j][k] = 0.0;
				I_memory[i][j][k] = 0.0;
			}
		}
	}

	//Ζʂ̗ʂ̃̊m
	msQc = new double[mDiv+1];
	msQn = new double[mDiv+1];


	// setting parameters
	if(basin > mthre_basin) {//setting parameters in channel
		double para_a, para_m; // parameter for setting channel width
		para_a = 1.061722301;
		para_m = 0.685081138;
		//width is determined by emperical formula in channel
		mB = para_a * pow((basin * (92.6886 * topoScale)/1000.0 * longitudinalLength/1000.0), para_m);

		mMan_channel   =  wMan_channel; // ͓̑exW
		mK = 1.0 / mB;
		mAlpha_channel = 1.0 / mMan_channel * pow(mK, mM-1.0) * sqrt(mG);

		//setting of parameters for runoff simulation nearby river channel by Tanaka 2014/6/25
		//Ζʒ́C\ʗɉep[^ł邽
		//\Ζʂ̒p[^Ƃė^ 2014/11/14 Tanaka
		//͓\Ζʂ̒ƓlɂD 2014/11/14 Tanaka
		msL = wsL;
		msB = wsB;

		msDx = msL / mDiv;


		mQc = new double[mDiv+1];
		mQn = new double[mDiv+1];
		mAc = new double[mDiv+1];
		mAn = new double[mDiv+1];
	}
	else {//setting parameters in slope
		//width is determined as grid width in basin
		msL = mL;
		msDx = mDx;
		msB = (92.6886 * topoScale) * longitudinalLength / mL;

	}




}
//ʂ̏
void Cell::initialize(double ini_lateral)
{
	double up_iniQ;
	double down_iniQ;

	up_iniQ = ini_lateral * 0.001 / 3600 * (basin-1) * (92.6886 * topoScale)*longitudinalLength;
	down_iniQ = ini_lateral * 0.001 / 3600 * basin * (92.6886 * topoScale)*longitudinalLength;
	
	
	for(int i=0; i<mDiv+1; i++){

		if(basin > mthre_basin) {// ͓̏ʐݒ
			mQc[i] = (up_iniQ * (mDiv - i) + down_iniQ * i) / mDiv;
			mAc[i] = pow(mQc[i]/mAlpha_channel, 1.0/mM);

			//͓Z̎Ζʕ̏ʂ̐ݒ by Tanaka 2014/6/25
			//---------------------------------------------------------
			//msQc[i] = ini_lateral * 0.001 / 3600 * (92.6886 * topoScale)*topoScale*longitudinalLength;//The previous code
			msQc[i] = ini_lateral * 0.001 / 3600 * (msL*i/mDiv) * msB;
		}
		else{// Ζʂ̏ʐݒ
//			msQc[i] = ini_lateral * 0.001 / 3600 * (92.6886 * topoScale)*longitudinalLength;
			msQc[i] = (up_iniQ * (mDiv - i) + down_iniQ * i) / mDiv;
		}
	}

	mQlc = ini_lateral * 0.001 *  92.6886 * topoScale * longitudinalLength / mL / 3600.0;
	mQln = ini_lateral * 0.001 *  92.6886 * topoScale * longitudinalLength / mL / 3600.0;
}

// ʂ𓾂
void Cell::getLateralRunoff(int n_day, int n_hour)
{
	int c_day, c_hour;
	c_day   = n_day;
	c_hour  = n_hour - 1;
	
	if(c_hour == 0){

		c_hour = 24;
		c_day--;
	}

	mQlc = ROFCell->value[c_day][c_hour-1];
	mQln = ROFCell->value[n_day][n_hour-1];

	// unit change [mm/hr]-->[m2/s]
	if(basin > mthre_basin) {
		// \Ζʂ̒Pʒ̑ʂ󂯎 2014/11/28
		mQln = mQln * 0.001 * msB / 3600.0;
		mQlc = mQlc * 0.001 * msB / 3600.0;
	}
	else{
		mQln = mQln * 0.001 *  92.6886 * topoScale * longitudinalLength / msL / 3600.0;
		mQlc = mQlc * 0.001 *  92.6886 * topoScale * longitudinalLength / msL / 3600.0;
	}
}



/*--------------------------------------------------------*/
/*----------------------- ovZ -----------------------*/
/*--------------------------------------------------------*/


// calculate runoff for 1 hour  ͓1ԕ̗ovZD͓ƎΖʂ̌vZʂ̊֐ōsDby Tanaka 2012/11/7
// calculate runoff and river flow for 1 hour 
// Ζ-͓Zɂ͎ΖʂƉ͓݂CΖʂ̗oʂ󂯂ĉ͓vZsDby Tanaka 2014/6/25
void Cell::CalculateRiver(int day, int hour, int nt) // Topography scale. 1 means 3 second.)
{
	//͓vZ̃p[^ by Tanaka 2014/6/25
	double dt = (double)mDt;
	double wC = 0.0;

	//oʂ̌vZ
	double Qsl = CalculateRunoff(day, hour, nt, 0.0, mQln);//ovZ͑^CalculateRunoffōsD

	//Ζʂ̗oʂ͓̑ʂƂė^D
	// lateral flow intensity.  (m2/s)
	//͓[̎Ζʂ痬 by Tanaka  2014/6/25
	//n`f[^̕\ɈˑȂ\Ζʂ̗ʂ͓ւ̒Pʒ̑ʂƂė^ 2014/11/28 Tanaka
	double wQl = Qsl/msB/msL * 92.6886 * topoScale * longitudinalLength / mL;

	// inflow from upstream 㗬[̗ (m3/s)
	double wUpInflow = 0.0;
	for(int i=0; i<numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̎ԕϗʂZbg
		// setting hourly mean inflow from upper grids
		wUpInflow += (double)upStreamGrid[i]->mQn_memory[day-1][hour-1][nt];
	}


	mQn[0] = wUpInflow; // ^[Qbg̏[痬闬
	mAn[0] = pow(mQn[0]/mAlpha_channel, 1.0/mM); // ^[Qbg̏[ł̒ʐfʐςvZ

	for (int i = 1; i <= mDiv; i++) {

		double wCa = mAlpha_channel*mM*pow(mAc[i-1], mM-1.0);

		double wQ = max(mQc[i], 0.5*(mQc[i-1]+mQn[i-1])+wQl*mDx);
		double wCb = pow(mAlpha_channel, 1.0/mM) * mM * pow(wQ, (mM-1.0)/mM);

		wC = 0.5 * (wCa + wCb);

		// ^[Qbg̊evZfʂł̗
		mQn[i] = (mQc[i] + mTheta * wC * (dt/mDx * mQn[i-1] + dt * wQl) 
			- (1. - mTheta) * wC * dt * ((mQc[i] - mQc[i-1])/mDx - wQl)) 
			/ (1. + mTheta * wC * dt / mDx);

		if (mQn[i] < 0.0) {
			mQn[i] = 0.0;
		}

		// ^[Qbg̊evZfʂł̐[vZ
		mAn[i] = pow(mQn[i]/mAlpha_channel, 1.0/mM);

	}

	// vZΖʉ[̗ʂL
	mQn_memory[day-1][hour-1][nt] = (float)mQn[mDiv];

	// update discharge and water depth ԗʂ̍XV
	for (int i=0; i <= mDiv; i++) {
		mQc[i] = mQn[i];
		mAc[i] = mAn[i];
	}
	mQlc = mQln;


}

// calculate runoff for 1 hour  Ζʂ1ԕ̗ovZD͓ƎΖʂ̌vZʂ̊֐ōsDby Tanaka 2012/11/7
// Ζʂ̗oʂ݂̂vZ֐ɕύXDvZꂽoʂ͂̂܂܉̎Ζʂ܂͉͓ɓnDby Tanaka 2014/6/25
void Cell::CalculateBasin(int day, int hour, int nt)
{
	double dt = (double)mDt;

	// inflow from upstream 㗬[̗ (m3/s)
	double wUpInflow = 0.0;
	for(int i=0; i<numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̎ԕϗʂZbg
		// setting hourly mean inflow from upper grids
		wUpInflow += (double)(upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}

	//㗬ё̋E^ĉ[̗oʂ擾D
	// stock simulation at the lower end of slope vZΖʉ[̗ʂL
	mQn_memory[day-1][hour-1][nt] = (float)CalculateRunoff(day, hour, nt, wUpInflow, mQln);
}



//Ζʕ̏㗬oʂ󂯎1Ԑ̉[̗oʂvZ֐ by Tanaka 2014/6/26
//ovZ̕@ςꍇ́CύX΂悢 by Tanaka 2014/6/26
double Cell::CalculateRunoff(int day, int hour, int nt, double upInflow, double wQl)
{
	double dt = (double)mDt;
	double mQlevel = 1.0;// ʂ̌vZl̊l (mm/hour)
	double mEps = 0.01;// vZx̕Wl
	double mQsmall = mQlevel * mEps * 0.001 / 3600.;//(mm/hour)-->(m/s)
	double mQeps = mQsmall * msDx;//(m^2/s)
	double wC = 0.0;
	double mCmin = 0.000001; // `dx̍ŏl (m/s)

	
	msQn[0] = upInflow; // ^[Qbg̏[痬闬

	for (int i = 1; i <= mDiv; i++) {

		// sOaEOaԗE\ʗlLl}eBbNEF[ufł̓`dx
		double q = 0.5*(msQc[i]+msQc[i-1]) / msB;

		if (q < mQm) {//}gNX̏ꍇ
			double h = pow(q*mBeta/(mVa*mDm),1/mBeta) * mDm;
			wC = mVa * pow(h/mDm , mBeta - 1.);
		}
		else if (q < mVa * (mDa - mDm) + mQm) { // }gNXEԗ̏ꍇ
			wC = mVa;
		}
		else {// \ʗĂꍇ
			double h0 =
			mDa + pow(((q - (mVa*(mDa-mDm) + mQm))/mAlpha_slope),1./mM);
			double v0 = pow(h0-mDa, mM - 1.);
			double q0 = mAlpha_slope * v0 * (h0-mDa) + mVa * (h0-mDm) + mQm;
			double q1;
			int count;
			count=0;
			while (1)
			{
				h0 = h0 - (q0 - q)/(mAlpha_slope * mM * v0 + mVa);
				v0 = pow(h0 - mDa, mM - 1.);
				q1 = mAlpha_slope*v0*(h0-mDa) + mVa*(h0-mDm) + mQm;
				if (fabs(q1 - q0) < mQeps) break;
				q0 = q1;

				if(count>10000){
					printf("Warning at PropagationSpeed.\n");
					wC = 0;
				}
				count+=1;
			}
			wC = mAlpha_slope * mM * v0 + mVa;
		}
		if(wC < mCmin) wC = mCmin;

		// ^[Qbg̊evZfʂł̗
		msQn[i] = (msQc[i] + mTheta * wC * (dt/msDx * msQn[i-1] + dt * wQl) 
			- (1. - mTheta) * wC * dt * ((msQc[i] - msQc[i-1])/msDx - wQl)) 
			/ (1. + mTheta * wC * dt / msDx);

		if (msQn[i] < 0.0) {
			msQn[i] = 0.0;
		}
	}

	// update discharge ԗʂ̍XV
	for (int i=0; i <= mDiv; i++) {
		msQc[i] = msQn[i];
	}

	return msQn[mDiv];

}

/*--------------------------------------------------------------*/
/*----------------------- vZʂ̎擾 -----------------------*/
/*--------------------------------------------------------------*/

float Cell::GetHourlyFlow(int day, int hour, int t_step_num) {
	// return hourly flow calculated by hourly data. Coded by YT.
	float hourlyflow=0;
	for(int k=0; k < t_step_num; k++){

		hourlyflow = hourlyflow + mQn_memory[day][hour][k];

	}
	hourlyflow = hourlyflow/t_step_num;
	return (hourlyflow);
}

float Cell::GetDailyFlow(int day, int t_step_num) {
	// return daily flow calculated by hourly data. Coded by Hunu.
	float dailyflow=0;
	int hour;
	for(hour=0; hour<24; hour++){
		float hourlyflow=0;
		for(int k=0; k<t_step_num; k++){

			hourlyflow = hourlyflow + mQn_memory[day][hour][k];

		}
		hourlyflow = hourlyflow/t_step_num;
		dailyflow = dailyflow + hourlyflow;
	}
	dailyflow = dailyflow/24;
	return (dailyflow);
}

float Cell::GetHourlyFlowMax(int day, int t_step_num) {
	// return hourly maxumum flow in a day. Coded by Hunu.
	float hourlyflowMax=0;
	int hour;
	for(hour=0; hour<24; hour++){
		float hourlyflow=0.0;
		for(int k=0; k<t_step_num; k++){
			
			hourlyflow = hourlyflow + mQn_memory[day][hour][k];
			
		}
		hourlyflow =  hourlyflow/t_step_num;
		
		if (hourlyflow >= hourlyflowMax){
			hourlyflowMax = hourlyflow;
		}
	}
	return (hourlyflowMax);
}

void Cell::deleteQandA(int Ndays)
{
	for(int i=0; i<Ndays; i++){
		for(int j=0; j<24; j++){
			
			delete[] mQn_memory[i][j];
		}
	}
	for(int i=0; i<Ndays; i++){
		
		delete[] mQn_memory[i];
	}
	delete[] mQn_memory;


	if(basin > mthre_basin){
		delete[] mQc;
		delete[] mQn;
		delete[] msQc;
		delete[] msQn;
	}
}


/*--------------------------------------------------------------------------------------------*/
/*-------------------------------------- _Z̊֐ --------------------------------------*/
/*--------------------------------------------------------------------------------------------*/


// Below is function settings for dam reservoir ȉ̓_fɊւ֐

// set initial condition of dam
void damCell::setDamGrid(
	char* wDamName,
	int wDamID,  // _̎ʔԍ
	int wDamCol, // _Obḧʒu̎w from West starting from 1
	int wDamRow, // _Obḧʒu̎w from South starting from 1
	int Col,     // Ώ̗ۗ̈
	int Row,     // Ώۗ̈̍s
	class Cell** cell, // _ݒ肷Obh̃|C^
	int wDamSimulationKind // 0: use observed dam outflow, 1: use dam model 
)
{
	strcpy(damName, wDamName);
	damID = wDamID;
	damRow = Row - wDamRow; // converting from North starting from 0.
	damCol = wDamCol-1; //  converting from West starting from 0.
	damSimulationKind = wDamSimulationKind; // 0: use observed dam outflow, 1: use dam model
	damGrid = &cell[damRow][damCol];
	damGrid->gridKind = 99;
	
	//string^̑Visual C++ō쓮Ȃ
	//2016/11/1 Tanaka T.
	sprintf(damFile, "./input/realDamOutflow/real%s.dat", damName);
//	string sDamFile;
//	sDamFile = damName;
//	sDamFile = "./input/realDamOutflow/real" + sDamFile + ".dat";
//	strcpy(damFile, sDamFile.c_str());

	// damSimulationKind = 0 ̏ꍇɃt@CJ
	if(damSimulationKind == 0){
		damFin.open(damFile);
		if (!damFin) {
			cout << "Dam outflow file cannot open." << endl;
			cout << "File Name : " << damFile << endl;
			exit(1);
		}
		cout << "Read : " << damFile << endl;
	}
}


void damCell::setDamInitialState(int Ndays, int nt)
{		
	storage = 0.0;
	
	S_memory = new float**[Ndays];
	
	for(int i=0; i < Ndays; i++){
		S_memory[i] = new float*[24];
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			S_memory[i][j] = new float[nt];
		}
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			for (int k=0; k<nt; k++) {
				S_memory[i][j][k] = 0.0;
			}
		}
	}
}


// set dam model parameters
void damCell::setDamParameter(double wFlood, double wPL, double wNL, double wSL)
{
	flood = wFlood; // ̃_̒߂^
	
	if(wPL == 0){s0 = wNL;}
	else{s0 = wPL;}
	s1 = wNL-s0;
	s2 = wSL-s0;
	
	cout << damName << " " << "s1=" << s1  << " " << "s2=" << s2 << '\n';
}


// read obserbed 1 month dam outflow
/*void damCell::readDamOutflow(int nday, int t_step_num)
// _ʂт̃f[^ɒu邽߂̊֐B
// Pʂ̃f[^ǂݍގdlƂȂĂ̂ŏCKvłB
{

	if (damSimulationKind != 0) {
		//2016/1/25 Tanaka T.
//		cout << " Not use dam outflow observed data." << endl;
//		return;
		cout << "Dam kind is set to non-zero" << endl;
		cout << "Dam name : " << damName << endl;
		exit(1);
	}

	int whour, wday;
	float damOutflow;

	
	// Reading daily dam outflow data
	
	ifstream fin(damFile);
	if (!fin) {
		cout << "Dam outflow file cannot open." << endl;
		cout << "File Name : " << damFile << endl;
		exit(1);
	}

	// set row and col of dam grid. row begins from south; col begins from west.
	// starting number is 1.

	for (int iday=0; iday < nday; iday++) {  // day loop
		for (int ihour=0; ihour < 24; ihour++) { // hour loop
			fin >> wday >> whour >> damOutflow; // read hourly dam outflow data
			//cout << " outflow = " << damOutflow << endl;
			for(int k=0; k < t_step_num; k++) {  // 1ԓ̌vZXebvJԂB
				damGrid->mQn_memory[iday][ihour][k] = damOutflow;  // ****Kv
			}
		}
	}
	// cout << " read input dam outflow data: " << damFile << endl;

	fin.close();
}
*/

// read obserbed 1 month dam outflow
void damCell::readHourlyDamOutflow(int day, int hour, int nt)
// _ʂт̃f[^ɒu邽߂̊֐B
// ԒPʂ̃f[^ǂݍ 2016/1/25 Tanaka T.
{

	if (damSimulationKind != 0) {
		//2016/1/25 Tanaka T.
//		cout << " Not use dam outflow observed data." << endl;
//		return;
		cout << "Dam kind is set to non-zero" << endl;
		cout << "Dam name : " << damName << endl;
		exit(1);
	}

	//1Ԃ1񂾂ǂݍ 2016/1/25 Tanaka T.
	double damOutflow;
	int wday, whour;
	if(nt == 0){
		damFin >> wday >> whour >> damOutflow; // read hourly dam outflow data
//		cout << damName << "  " << wday << " " << whour << " " << damOutflow << endl;
		damGrid->mQn_memory[day-1][hour-1][nt] = damOutflow;
	}
	else{
		damGrid->mQn_memory[day-1][hour-1][nt] = damGrid->mQn_memory[day-1][hour-1][0];
//		cout << damName << "  " << day << " " << hour << " "  << damGrid->mQn_memory[day-1][hour-1][0] << endl;
	}
}


// calculate dam outflow for 1 hour
//void damCell::calculateDamOutflow(int imonth, int day, int hour)
//_́A_ɂ̂Ń[U[̎ŕύX̕KvB
void damCell::calculateDamOutflow(int day, int hour, int nt)
{

	if (damSimulationKind == 0) { // use dam outflow observed data. у_ʂgꍇBɕԂB
					//у_ʂgꍇ́CreadHourlyDamOutflow s1ԃf[^ǂݍ 2016/1/25 Tanaka T.
		readHourlyDamOutflow(day, hour, nt);
		return;
	}
	int dt = damGrid->mDt;
	double damOutflow; // outflow from dam (m3/s)
	double wUpInflow; // total inflow to dam (m3/s)

	wUpInflow = 0.0; // total inflow to dam (m3/s)

	// inflow from upstream 㗬[̗ (m3/s)
	for(int i=0; i < damGrid->numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̗ʂZbg
		// setting inflow from upper grids
		wUpInflow += (double)(damGrid->upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}
	
	// add raleral inflow
	// lateral flow intensity.  (m3/s)
	wUpInflow += (2.0 *(damGrid->mQln) * (damGrid->msL)); 


	// ftHg̃_
	switch(damSimulationKind){
	case 1:
		if((wUpInflow<flood && storage<=s1) || (wUpInflow>flood && storage>=s2))
			damOutflow = wUpInflow;
		else
			damOutflow = flood;
		break;
	case 2://ʂlȂꍇDC storage ͌`傫Ȃ邱ƂɒӁD 2015/7/10 Tanaka T.
		if(wUpInflow>flood){
			damOutflow = flood;
		}
		else{
			damOutflow = wUpInflow;
		}
		break;
	default:
		cout << "Set dam type to 1 or 2. Modelling of other types of dam operation is instructed in the manual." << endl;
		exit(1);
	}


	// ʃ_ւ̑Ή
	/*--------------------------------------------------------------------------*/
	// 여̃_̗
	//if(damID==2){
	//	static double takayamaImax;
	//	if(wUpInflow>=takayamaImax)  takayamaImax = wUpInflow;
	//	if((wUpInflow<flood && storage<=s1) || (wUpInflow>flood && storage>=s2))
	//		damOutflow = wUpInflow;
	//	else
	//		damOutflow = (takayamaImax - flood)*0.24 + flood;
	//}
	/*--------------------------------------------------------------------------*/

	storage += ((wUpInflow - damOutflow) * double(dt));
	
	S_memory[day-1][hour-1][nt] = (float)storage; 
	damGrid->I_memory[day-1][hour-1][nt] = (float)wUpInflow; 
	damGrid->mQn_memory[day-1][hour-1][nt] = (float)damOutflow; 
	
}


float damCell::GetHourlyStorage(int day, int hour, int t_step_num) {
	float hS=0;
	for(int k=0; k < t_step_num; k++){

		hS += S_memory[day][hour][k];

	}
	hS = hS/t_step_num + s0;
	return (hS);
}


void damCell::deleteS(int Ndays)
{
	for(int i=0; i<Ndays; i++){
		for(int j=0; j<24; j++){
			
			delete[] S_memory[i][j];
		}
	}
	for(int i=0; i<Ndays; i++){
		
		delete[] S_memory[i];
	}
	delete[] S_memory;

	// damSimulationKind = 0 ̏ꍇɃt@CJ
	if(damSimulationKind == 0){
		damFin.close();
	}
}


// Below is function settings for natural reservoir ȉ͐`rfɊւ֐
float Cell::GetHourlyInflow(int day, int hour, int t_step_num) {
	// return hourly flow calculated by hourly data. Coded by YT.
	float hI=0;
	for(int k=0; k < t_step_num; k++){

		hI += I_memory[day][hour][k];

	}
	hI /= t_step_num;
	return (hI);
}


/*----------------------------------------------------------------------------------------------*/
/*----------------------- `rfirz_̃Zpj -----------------------*/
/*----------------------------------------------------------------------------------------------*/

// set initial condition of reservoir
void resCell::setResGrid(
	char* wResName,
	int wResID,  // r̎ʔԍ
	int wResCol, // rObḧʒu̎w from West starting from 1
	int wResRow, // rObḧʒu̎w from South starting from 1
	int Col,     // Ώۗ̈̍s
	int Row,     // Ώ̗ۗ̈
	class Cell** cell // _ݒ肷Obh̃|C^
)
{
	strcpy(resName, wResName);
	resID = wResID;
	resRow = Row - wResRow; // converting from North starting from 0.
	resCol = wResCol-1; //  converting from West starting from 0.
	resGrid = &cell[resRow][resCol];
	resGrid->gridKind = 100;
}


// set initial discharge
void resCell::setResInitialState()
{	
	preInflow = 0.0;
	resOutflow = 0.0;
}


// set reservoir model parameters
void resCell::setResParameter(int wrK)
{
	int dt = resGrid->mDt;
	
	rK = wrK; // set parameter rK
	a = double(2*rK-dt) / double(2*rK+dt);
	b = double(dt) / double(2*rK+dt);
	
	cout << resName << " " << "k=" << rK << '\n';
}


// calculate reservoir outflow for 1 hour
void resCell::calculateResOutflow(int day, int hour, int nt)
{
	double wUpInflow; // total inflow to reservoir (m3/s)

	wUpInflow = 0.0; 

	// inflow from upstream 㗬[̗ (m3/s)
	for(int i=0; i < resGrid->numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̗ʂZbg
		// setting inflow from upper grids
		wUpInflow += (double)(resGrid->upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}
	
	// add raleral inflow
	// lateral flow intensity.  (m3/s)
	wUpInflow += (2.0 * (resGrid->mQln) * (resGrid->msL)); 

	resOutflow = a*resOutflow + b*(preInflow+wUpInflow);
	preInflow = wUpInflow;
	
	resGrid->I_memory[day-1][hour-1][nt] = (float)wUpInflow;
	resGrid->mQn_memory[day-1][hour-1][nt] = (float)resOutflow; 
}


